stages:
  - build
  - test
  - deploy
  
sast:
  stage: test
include:
- template: Security/SAST.gitlab-ci.yml

variables:
  SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
  GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task
sonarcloud-check:
  image:
    name: sonarsource/sonar-scanner-cli:latest
    entrypoint: [""]
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
  script:
    - sonar-scanner

build-docker:
  only:
    - main
  retry: 2
  stage: build
  image: docker:24.0.5
  services:
    - docker:24.0.5-dind
  before_script:
    - echo -n $DOCKER_HUB_TOKEN | docker login -u $DOCKER_HUB_USER --password-stdin docker.io
  script:
    - docker build --tag $DOCKER_HUB_USER/$CI_PROJECT_NAME:latest --no-cache .
    - |
      for i in $(seq 3); do  # Retry 3 times (adjust as needed)
        docker push docker.io/$DOCKER_HUB_USER/$CI_PROJECT_NAME:latest && break
        echo "Retry #$i: Docker build or push failed. Retrying..."
        sleep 5  # Retry interval (adjust as needed)
      done

deploy-job:      # This job runs in the deploy stage.
  only:
    - main
  retry: 2
  stage: deploy  # It only runs when *both* jobs in the test stage complete successfully
  before_script:
    - 'which ssh-agent || ( apt-get update -y && apt-get install openssh-client -y )'
    - mkdir -p ~/.ssh
    - eval $(ssh-agent -s)
    - '[[ -f /.dockerenv ]] && echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'
  script:
    - echo "Deploying application..."
    - chmod 600 $SSH_KEY_VPS
    - ssh -p22 -i $SSH_KEY_VPS $SSH_USER@$SSH_IP "cd ./cube/$CI_PROJECT_NAME/ && git checkout main && git pull"
    - ssh -p22 -i $SSH_KEY_VPS $SSH_USER@$SSH_IP "microk8s kubectl delete -k ./cube/$CI_PROJECT_NAME/kubernetes/overlays/recette/" || true
    - ssh -p22 -i $SSH_KEY_VPS $SSH_USER@$SSH_IP "microk8s kubectl apply -k ./cube/$CI_PROJECT_NAME/kubernetes/overlays/recette/"
    - echo "Application successfully deployed."